<?php

namespace Schaffen\SerasaRemessa\Http\Advanced\PF\Blocks;

use Schaffen\SerasaRemessa\Utils\Record;
use Schaffen\SerasaRemessa\Utils\RecordColumn;
use Schaffen\SerasaRemessa\Utils\Util;

class RegP006 extends Record {
    protected $templateColumns = [
        [
           "name" => "type_rule", 
           "position" => "1", 
           "size" => "4", 
           "type" => RecordColumn::TYPE_ALPHANUMERIC 
        ], 
        [
           "name" => "grafias", 
           "position" => "5", 
           "size" => "1", 
           "type" => RecordColumn::TYPE_ALPHANUMERIC 
        ], 
        [
           "name" => "det_graf", 
           "position" => "6", 
           "size" => "1", 
           "type" => RecordColumn::TYPE_ALPHANUMERIC 
        ], 
        [
           "name" => "res_sint", 
           "position" => "7", 
           "size" => "1", 
           "type" => RecordColumn::TYPE_ALPHANUMERIC 
        ], 
        [
           "name" => "consultas", 
           "position" => "8", 
           "size" => "1", 
           "type" => RecordColumn::TYPE_ALPHANUMERIC 
        ], 
        [
           "name" => "participa", 
           "position" => "9", 
           "size" => "1", 
           "type" => RecordColumn::TYPE_ALPHANUMERIC 
        ], 
        [
           "name" => "porcentagem", 
           "position" => "10", 
           "size" => "2", 
           "type" => RecordColumn::TYPE_NUMERIC
        ], 
        [
           "name" => "ocorren", 
           "position" => "12", 
           "size" => "2", 
           "type" => RecordColumn::TYPE_ALPHANUMERIC 
        ], 
        [
           "name" => "res_negativ", 
           "position" => "14", 
           "size" => "1", 
           "type" => RecordColumn::TYPE_ALPHANUMERIC 
        ], 
        [
           "name" => "perndencias", 
           "position" => "15", 
           "size" => "1", 
           "type" => RecordColumn::TYPE_ALPHANUMERIC 
        ], 
        [
           "name" => "divida_venc", 
           "position" => "16", 
           "size" => "1", 
           "type" => RecordColumn::TYPE_ALPHANUMERIC 
        ], 
        [
           "name" => "achei_ccf", 
           "position" => "17", 
           "size" => "1", 
           "type" => RecordColumn::TYPE_ALPHANUMERIC 
        ], 
        [
           "name" => "recheque", 
           "position" => "18", 
           "size" => "1", 
           "type" => RecordColumn::TYPE_ALPHANUMERIC 
        ], 
        [
           "name" => "protesto", 
           "position" => "19", 
           "size" => "1", 
           "type" => RecordColumn::TYPE_ALPHANUMERIC 
        ], 
        [
           "name" => "acao_judic", 
           "position" => "20", 
           "size" => "1", 
           "type" => RecordColumn::TYPE_ALPHANUMERIC 
        ], 
        [
           "name" => "falencia", 
           "position" => "21", 
           "size" => "1", 
           "type" => RecordColumn::TYPE_ALPHANUMERIC 
        ], 
        [
           "name" => "filler_1", 
           "position" => "22", 
           "size" => "1", 
           "type" => RecordColumn::TYPE_ALPHANUMERIC 
        ], 
        [
           "name" => "historico", 
           "position" => "23", 
           "size" => "1", 
           "type" => RecordColumn::TYPE_ALPHANUMERIC 
        ], 
        [
           "name" => "prev_pg", 
           "position" => "24", 
           "size" => "1", 
           "type" => RecordColumn::TYPE_ALPHANUMERIC 
        ], 
        [
           "name" => "compr_prev", 
           "position" => "25", 
           "size" => "1", 
           "type" => RecordColumn::TYPE_ALPHANUMERIC 
        ], 
        [
           "name" => "referen", 
           "position" => "26", 
           "size" => "1", 
           "type" => RecordColumn::TYPE_ALPHANUMERIC 
        ], 
        [
           "name" => "documentos", 
           "position" => "27", 
           "size" => "1", 
           "type" => RecordColumn::TYPE_ALPHANUMERIC 
        ], 
        [
           "name" => "compacta_end", 
           "position" => "28", 
           "size" => "1", 
           "type" => RecordColumn::TYPE_ALPHANUMERIC 
        ], 
        [
           "name" => "filler_2", 
           "position" => "29", 
           "size" => "1", 
           "type" => RecordColumn::TYPE_ALPHANUMERIC 
        ], 
        [
           "name" => "quer_restr", 
           "position" => "30", 
           "size" => "1", 
           "type" => RecordColumn::TYPE_ALPHANUMERIC 
        ], 
        [
           "name" => "filler_3", 
           "position" => "31", 
           "size" => "85", 
           "type" => RecordColumn::TYPE_ALPHANUMERIC 
        ] 
    ];
     
    public function __construct($values = null) {
        $this->createColumns();

        if($values !== null) {
            $this->setValues($values);
        }
    }

    private function setValues($values) {
        $values["type_rule"] = "P006";
        $values["grafias"] = "S";
        $values["det_graf"] = "S";
        $values["res_sint"] = "S";
        $values["consultas"] = "S";
        $values["participa"] = "S";
        $values["porcentagem"] = "01";
        $values["ocorren"] = "05";
        $values["res_negativ"] = "S";
        $values["perndencias"] = "S";
        $values["divida_venc"] = "S";
        $values["achei_ccf"] = "S";
        $values["recheque"] = "S";
        $values["protesto"] = "S";
        $values["acao_judic"] = "S";
        $values["falencia"] = "S";
        $values["filler_1"] = " ";
        $values["historico"] = "N";
        $values["prev_pg"] = "S";
        $values["compr_prev"] = "S";
        $values["referen"] = "N";
        $values["documentos"] = "T";
        $values["compacta_end"] = "S";
        $values["filler_2"] = " ";
        $values["quer_restr"] = "S";
        $values["filler_3"] = "";

        $this->setColumnsValues($values);
    }
}