<?php 

namespace Schaffen\SerasaRemessa\Http\Advanced\PF;
use Schaffen\SerasaRemessa\Http\Advanced\PF\Blocks\ClosingBlock;

use Schaffen\SerasaRemessa\Http\Advanced\PF\Blocks\MainBlock;
use Schaffen\SerasaRemessa\Http\Advanced\PF\Blocks\RegB376;
use Schaffen\SerasaRemessa\Http\Advanced\PF\Blocks\RegF900;
use Schaffen\SerasaRemessa\Http\Advanced\PF\Blocks\RegN001;
use Schaffen\SerasaRemessa\Http\Advanced\PF\Blocks\RegP002;
use Schaffen\SerasaRemessa\Http\Advanced\PF\Blocks\RegP006;

use Schaffen\SerasaRemessa\Http\Advanced\PF\Blocks\RegB001;
use Schaffen\SerasaRemessa\Http\Advanced\PF\Blocks\RegB002;
use Schaffen\SerasaRemessa\Http\Advanced\PF\Blocks\RegB003;
use Schaffen\SerasaRemessa\Http\Advanced\PF\Blocks\RegB004;
use Schaffen\SerasaRemessa\Http\Advanced\PF\Blocks\RegB005;
use Schaffen\SerasaRemessa\Http\Advanced\PF\Blocks\RegB006;
use Schaffen\SerasaRemessa\Http\Advanced\PF\Blocks\RegB011;
use Schaffen\SerasaRemessa\Http\Advanced\PF\Blocks\RegB012;
use Schaffen\SerasaRemessa\Http\Advanced\PF\Blocks\RegB013;
use Schaffen\SerasaRemessa\Http\Advanced\PF\Blocks\RegB014;
use Schaffen\SerasaRemessa\Http\Advanced\PF\Blocks\RegB015;

use Schaffen\SerasaRemessa\Http\Advanced\PF\Blocks\RegB054;
use Schaffen\SerasaRemessa\Http\Advanced\PF\Blocks\RegB280;
use Schaffen\SerasaRemessa\Http\Advanced\PF\Blocks\RegB352;
use Schaffen\SerasaRemessa\Http\Advanced\PF\Blocks\RegB35P;
use Schaffen\SerasaRemessa\Http\Advanced\PF\Blocks\RegB353;
use Schaffen\SerasaRemessa\Http\Advanced\PF\Blocks\RegB354;
use Schaffen\SerasaRemessa\Http\Advanced\PF\Blocks\RegB356;
use Schaffen\SerasaRemessa\Http\Advanced\PF\Blocks\RegB357;
use Schaffen\SerasaRemessa\Http\Advanced\PF\Blocks\RegB358;
use Schaffen\SerasaRemessa\Http\Advanced\PF\Blocks\RegB359;
use Schaffen\SerasaRemessa\Http\Advanced\PF\Blocks\RegB360;
use Schaffen\SerasaRemessa\Http\Advanced\PF\Blocks\RegB361;

use Schaffen\SerasaRemessa\Http\Advanced\PF\Blocks\RegB362;
use Schaffen\SerasaRemessa\Http\Advanced\PF\Blocks\RegB363;
use Schaffen\SerasaRemessa\Http\Advanced\PF\Blocks\RegB364;
use Schaffen\SerasaRemessa\Http\Advanced\PF\Blocks\RegB365;
use Schaffen\SerasaRemessa\Http\Advanced\PF\Blocks\RegB366;
use Schaffen\SerasaRemessa\Http\Advanced\PF\Blocks\RegB367;
use Schaffen\SerasaRemessa\Http\Advanced\PF\Blocks\RegB368;

use Schaffen\SerasaRemessa\Http\Advanced\PF\Blocks\RegA900;
use Schaffen\SerasaRemessa\Http\Advanced\PF\Blocks\RegB900;


class Response {
    use Translator;
    
    private $requestBlocks = [];
    private $responseBlocks = [];

    private $validReqBlocks = [
        'B49C' => MainBlock::class,
        'N001' => RegN001::class,
        'P002' => RegP002::class,
        'P006' => RegP006::class
    ];

    private $validResBlocks = [
        'B001' => RegB001::class,
        'B002' => RegB002::class,
        'B003' => RegB003::class,
        'B004' => RegB004::class,
        'B005' => RegB005::class,
        'B006' => RegB006::class,
        'B011' => RegB011::class,
        'B012' => RegB012::class,
        'B013' => RegB013::class,
        'B014' => RegB014::class,
        'B015' => RegB015::class,

        'B054' => RegB054::class,
        'B280' => RegB280::class,
        'B352' => RegB352::class,
        'B35P' => RegB35P::class,
        'B353' => RegB353::class,
        'B354' => RegB354::class,
        'B356' => RegB356::class,
        'B357' => RegB357::class,
        'B358' => RegB358::class,
        'B359' => RegB359::class,
        'B360' => RegB360::class,
        'B361' => RegB361::class,

        'B362' => RegB362::class,
        'B363' => RegB363::class,
        'B364' => RegB364::class,
        'B365' => RegB365::class,
        'B366' => RegB366::class,
        'B367' => RegB367::class,
        'B368' => RegB368::class,

        'B376' => RegB376::class,

        'F900' => RegF900::class,

        'A900' => RegA900::class,
        'B900' => RegB900::class,
        'T999' => ClosingBlock::class
    ];

    public static function load($body) {
        $mainBlock = substr($body, 0, 400);
        $response = new self();
        $response->loadBlocks(array_merge([$mainBlock], str_split(substr($body, 400), 115)));
        return $response;
    }

    private function loadBlocks($blocks) {
        foreach($blocks as $strBlock) {
            $blockCode = substr($strBlock, 0, 4);
            if(isset($this->validReqBlocks[$blockCode])) {
                $block = new $this->validReqBlocks[$blockCode]();
                $block->load($strBlock);
                array_push($this->requestBlocks, $block);
            }
            
            $blockCode = substr($strBlock, 0, 4);
            if(isset($this->validResBlocks[$blockCode])) {
                $block = new $this->validResBlocks[$blockCode]();
                $block->load($strBlock);
                array_push($this->responseBlocks, $block);
            }
        }
    }

    public function getRequestBlocks() {
        return array_map(function($block) {
            return $block->getValues();
        }, $this->requestBlocks);
    }

    public function getResponseBlocks() {
        return collect(array_map(function($block) {
            return $block->getValues();
        }, $this->responseBlocks));
    }
}